cordova.define("org.devgeeks.Canvas2ImagePlugin.Canvas2ImagePlugin", function(require, exports, module) {
//
//  Canvas2ImagePlugin.js
//  Canvas2ImagePlugin PhoneGap/Cordova plugin
//
//  Created by Tommy-Carlos Williams on 29/03/12.
//  Copyright (c) 2012 Tommy-Carlos Williams. All rights reserved.
//  MIT Licensed
//
//  saveImageDataToFile added by Mike Holenderski
//

  module.exports = {
    
    saveImageDataToLibrary:function(successCallback, failureCallback, canvasId) {
        // successCallback required
        if (typeof successCallback != "function") {
            console.log("Canvas2ImagePlugin Error: successCallback is not a function");
        }
        else if (typeof failureCallback != "function") {
            console.log("Canvas2ImagePlugin Error: failureCallback is not a function");
        }
        else {
            var canvas = (typeof canvasId === "string") ? document.getElementById(canvasId) : canvasId;
            var imageData = canvas.toDataURL().replace(/data:image\/png;base64,/,'');
            return cordova.exec(successCallback, failureCallback, "Canvas2ImagePlugin","saveImageDataToLibrary",[imageData]);
        }
    },
    
    saveImageDataToFile: function(successCallback, failureCallback, canvasId, fileName) {	
			// successCallback required
			if (typeof successCallback != "function") {
				console.log("Canvas2ImagePlugin Error: successCallback is not a function");
			}
			else if (typeof failureCallback != "function") {
				console.log("Canvas2ImagePlugin Error: failureCallback is not a function");
			}
			else {
				var canvas = (typeof canvasId === "string") ? document.getElementById(canvasId) : canvasId;
				var imageData = canvas.toDataURL().replace(/data:image\/png;base64,/,'');
				return cordova.exec(successCallback, failureCallback, "Canvas2ImagePlugin","saveImageDataToFile",[imageData, fileName]);
			}
		},

    saveBase64DataToFile: function(successCallback, failureCallback, imageData, fileName) {  
      // successCallback required
      if (typeof successCallback != "function") {
        console.log("Canvas2ImagePlugin Error: successCallback is not a function");
      }
      else if (typeof failureCallback != "function") {
        console.log("Canvas2ImagePlugin Error: failureCallback is not a function");
      }
      else {
        imageData = imageData.replace(/data:image\/png;base64,/,'');
        imageData = imageData.replace(/data:image\/jpeg;base64,/,'');
        return cordova.exec(successCallback, failureCallback, "Canvas2ImagePlugin","saveImageDataToFile",[imageData, fileName]);
      }
    }

  };
  

});
